unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls
  ,iBprocs;
type
  TForm1 = class(TForm)
    bAttachDb: TButton;
    bStartTransaction: TButton;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    procedure bAttachDbClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bStartTransactionClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  dbhandle:isc_db_handle;
  Transaction :isc_tr_handle;
  TEB:isc_teb;




implementation

{$R *.DFM}
function GetVersion: String;
var
  local_buffer: array[0..1024 - 1] of Char;
  DBInfoCommand: Char;
  status: status_vector;
begin
  DBInfoCommand := Char(isc_info_version);
  isc_database_info(@Status, @dbHandle, 1, @DBInfoCommand,
                                          1024 , local_buffer);
  local_buffer[5 + ord(local_buffer[4])] := #0;
  result := String(PChar(@local_buffer[5]));

end;
function GetDBSiteName: String;
var
  local_buffer: array[0..1024 - 1] of Char;
  p: PChar;
  DBInfoCommand: Char;
  status: status_vector;
begin
  DBInfoCommand := Char(isc_info_db_id);
  isc_database_info(@Status, @dbHandle, 1, @DBInfoCommand,
                        1024, local_buffer);
  p := @local_buffer[5 + ord(local_buffer[4])]; // DBSiteName Length
  p := p + ord(p^) + 1;                         // End of DBSiteName
  p^ := #0;                                     // Null it.
  result := String(PChar(@local_buffer[6 + ord(local_buffer[4])]));
end;

procedure HandleIBErrors(status:pstatus_vector);
var
  buffer:array[0..255] of char;
  errMsg,lastMsg:string;
  errCode:isc_status;

begin
  errMsg:='';
  repeat
     errCode:=isc_interprete(@buffer,@status);
     if lastMsg <> strPas( buffer) then
       begin
         lastMsg:=strPas( Buffer );
         if length ( errMsg) <> 0 then errMsg:=errMsg+#13#10;
          errMsg:=errMsg+lastMsg;
       end;
  until errCode=0;
  raise Exception.Create(errMsg);
end;





function AttachDatabase(DatabaseName, userName, password: string): isc_db_handle;
var Buffer: array[0..1023] of char;
  BufPtr: integer;
  dbName: array[0..255] of char;
  status: status_vector;
  IBerrCode: isc_status;
  dbHandle: isc_db_handle;
begin
  StrPCopy(dbName, DatabaseName);
  dbHandle := nil;
    {init the Database Param buffer}
  FillChar(Buffer, sizeof(Buffer), #0);
  BufPtr := 0;
  Buffer[0] := char(isc_dpb_version1);
  inc(BufPtr);
  Buffer[BufPtr] := char(isc_dpb_user_name);
  inc(BufPtr);
  Buffer[BufPtr] := char(length(username));
  inc(BufPtr);
  StrPCopy(@Buffer[BufPtr], username);
  inc(BufPtr, length(username));
  Buffer[BufPtr] := char(isc_dpb_password);
  inc(BufPtr);
  Buffer[BufPtr] := char(length(password));
  inc(BufPtr);
  StrPCopy(@Buffer[BufPtr], password);
    inc(BufPtr, length(password));
    {Attach Database Call }
  try
  IBerrCode := isc_attach_database(@status, 0, @DBName, @DBHandle, BufPtr, @Buffer);
  except
  if IBerrCode <> 0 then HandleIBErrors(@status);
  end;
  Result := dbHandle;
end;

procedure DetachDatabase(dbHandle: isc_db_handle);
var
  status: status_vector;
  IBerrorCode: isc_status;
begin
  IBerrorCode:= isc_detach_database(@status, @dbHandle);
  if IBerrorCode <> 0 then HandleIBErrors(@status);
end;

function StartTransaction (const tebarray:array of isc_teb):isc_tr_handle;
 var
   status:status_vector;
   IBerrCode:isc_status;

 begin
   result:=0;
   IBerrCode:=isc_start_multiple(@status,@result,1,@tebarray);
   //IBerrCode:=isc_start_transaction(@status,@result,1,@dbhandle,1,@tebarray);

   if IBerrcode <> 0 then HandleIBErrors(@status);
 end;



procedure TForm1.bAttachDbClick(Sender: TObject);
begin
LoadApi();
dbhandle:=AttachDatabase('d:\InterBase Corp\InterBase\examples\database\employee.gdb','sysdba','masterkey');


end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
freeApi();
end;

procedure TForm1.bStartTransactionClick(Sender: TObject);
var errcode:integer;
status: status_vector;
 begin
  teb.db_ptr:=@DBHandle;
  teb.tpb_len:=0;
  teb.tpb_ptr:=nil;
  Transaction:=StartTransaction(teb);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  memo1.clear;
  Memo1.lines.add('Version:'+GetVersion);
  memo1.Lines.add('Site:'+getDBSitename)

end;

end.

